﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using System.Xml.XPath;
using System.Windows.Media.Effects;
using System.Web;
using System.Data;
using System.Data.SqlServerCe;

namespace menu
{
    /// <summary>
    /// Lógica de interacción para Cargar.xaml
    /// </summary>
    public partial class Cargar : Window
    {
        int proc = 0;
        int subs = 0;
        int tarea = -1;
        int act = -1;
        int v, i;
        int rectangulos = 0;
        int procesos = 0;

        decimal cX;
        decimal cY;

        Rectangle[,] rec;
        Rectangle[,] rec_sub;
        Rectangle[,] rec_ant;
        SqlCeDataReader reader = null;
        SqlCeConnection conn = new SqlCeConnection("Data Source ='C:/Documents and Settings/LeticiaOsacar/Escritorio/ejemplos_c#/menu1/interfaz.sdf'; Password = 'interfaz'");
        XmlDocument xDoc = new XmlDocument();

        string p;
        string[] duras = null;
        string[] deses = null;
        string[] titus = null;
        string[] aes = null;

        public Cargar()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = -1;
            comboBox1.Visibility = Visibility.Hidden;
            button3.Visibility = Visibility.Hidden;
            label3.Visibility = Visibility.Hidden;
            label5.Visibility = Visibility.Hidden;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {  
            crear_xml(); 
            button1.Visibility = Visibility.Hidden;   
            label2.Content = "Seleccione el proceso que desea comprobar...";
            label2.FontSize = 13;
        }

        public void crear_xml() 
        {
            SqlCeConnection conn = null;
            XmlTextWriter myXmlTextWriter = new XmlTextWriter("C:/Documents and Settings/LeticiaOsacar/Escritorio/ejemplos_c#/menu1/menu1/xml2.xml", System.Text.Encoding.UTF8);

            try
            {
                conn = new SqlCeConnection("Data Source ='C:/Documents and Settings/LeticiaOsacar/Escritorio/ejemplos_c#/menu1/interfaz.sdf'; Password = 'interfaz'");
                conn.Open();
             
                int proc = comboBox1.SelectedIndex;

                //Comando para contar cuantos procesos tenemos
                SqlCeCommand cmd1 = conn.CreateCommand();
                cmd1.CommandText = "SELECT COUNT(*) FROM Proceso";
                reader = cmd1.ExecuteReader();
                cmd1.ExecuteNonQuery();

                while (reader.Read())
                {
                    //Cuantos procesos tenemos
                    procesos = Int32.Parse(reader[0].ToString());   
                }

                //Comando para sacar el nombre de los procesos y ponerlos en el combobox
                SqlCeCommand cmd2 = conn.CreateCommand();
                cmd2.CommandText = "SELECT nombre FROM Proceso";
                reader = cmd2.ExecuteReader();
                cmd2.ExecuteNonQuery();
                comboBox1.Visibility = Visibility.Visible;

                while (reader.Read()) 
                {
                    //Rellenamos el combobox
                    comboBox1.Items.Add(reader["nombre"].ToString());
                }

                int num_actividad = 0;
                
                SqlCeCommand cmd5 = conn.CreateCommand();
                cmd5.CommandText = "SELECT nombre FROM Proceso";
                reader = cmd5.ExecuteReader();
                cmd5.ExecuteNonQuery();

                string[] nom_proc = new string[10]; 
                int h =0;
                while (reader.Read())
                {
                    nom_proc[h] = reader[0].ToString();
                    h++;
                }

                myXmlTextWriter.Formatting = Formatting.Indented;
                myXmlTextWriter.WriteStartDocument(false);

                myXmlTextWriter.WriteStartElement("Procesos");
                
                    for (int x = 0; x <= procesos - 1; x++)
                    {
                        myXmlTextWriter.WriteStartElement("Proceso");
                            
                            myXmlTextWriter.WriteStartElement("Id_proceso");
                                myXmlTextWriter.WriteString(""+ nom_proc[x]);
                            myXmlTextWriter.WriteEndElement();    

                            SqlCeCommand cmd6 = conn.CreateCommand();
                            cmd6.CommandText = "SELECT actividad FROM esta_formado_por WHERE nombre='" + nom_proc[x] + "'";
                            reader = cmd6.ExecuteReader();
                            cmd6.ExecuteNonQuery();

                            string[] nom_act = new string[10];
                            int k = 0; 
                            while(reader.Read())
                            {
                                nom_act[k] = reader[0].ToString();
                                k++;
                            }

                            SqlCeCommand cmd7 = conn.CreateCommand();
                            cmd7.CommandText = "SELECT COUNT (actividad) FROM esta_formado_por WHERE nombre= '" + nom_proc[x]+ "'";
                            reader = cmd7.ExecuteReader();
                            cmd7.ExecuteNonQuery();
                            while (reader.Read())
                            {
                                num_actividad = Int32.Parse(reader[0].ToString());
                            }

                            for (int q = 0; q <= num_actividad -1; q++)
                            {
                                myXmlTextWriter.WriteStartElement("Actividad");
                                    myXmlTextWriter.WriteStartElement("Id_act");
                                    myXmlTextWriter.WriteString("" + nom_act[q]);
                                    myXmlTextWriter.WriteEndElement();
                                    //myXmlTextWriter.WriteString("\n");

                                    string[] desc = new string[10];
                                    string[] titulo = new string[10];
                                    string[] dura = new string[10];
                                    int b=0;

                                    SqlCeCommand cmd8 = conn.CreateCommand();
                                    cmd8.CommandText = "SELECT duracion , descripcion , titulo FROM actividad WHERE actividad= '" + nom_act[q] + "'";
                                    reader = cmd8.ExecuteReader();
                                    cmd8.ExecuteNonQuery();
                                    while (reader.Read())
                                    {
                                        dura[b] = reader[0].ToString();
                                        desc[b] = reader[1].ToString();
                                        titulo[b] = reader[2].ToString();
                                        myXmlTextWriter.WriteElementString("Duracion", null, "" + Int32.Parse(dura[b]));
                                        myXmlTextWriter.WriteElementString("Descripcion", null, ""+ desc[b]);
                                        myXmlTextWriter.WriteElementString("Titulo", null, "" + titulo[b]);
                                        b++;
                                    }
                                
                                myXmlTextWriter.WriteStartElement("Subactividades");
                                
                                    string[] s = new string[15];
                                    string[] sub = new string[20];
                                    string[] desc_s = new string[10];
                                    string[] titulo_s = new string[10];
                                    int w = 0;
                                    int num_subactividad = 0;

                                    SqlCeCommand cmd4 = conn.CreateCommand();
                                    cmd4.CommandText = "SELECT COUNT (cod_sub) FROM subactividad WHERE cod_act= '" + nom_act[q] + "'";
                                    reader = cmd4.ExecuteReader();
                                    cmd4.ExecuteNonQuery();

                                    while (reader.Read())
                                    {
                                        num_subactividad = Int32.Parse(reader[0].ToString());
                                    }


                                    SqlCeCommand cmd10 = conn.CreateCommand();
                                    cmd10.CommandText = "SELECT cod_sub , descripcion , titulo FROM subactividad WHERE cod_act= '" + nom_act[q] + "'";
                                    reader = cmd10.ExecuteReader();
                                    cmd10.ExecuteNonQuery();

                                    for (int a = 0; a <= num_subactividad - 1; a++)
                                    {
                                        while (reader.Read())
                                            {
                                                s[w] = reader[0].ToString();
                                                myXmlTextWriter.WriteStartElement("Subactividad");
                                                    myXmlTextWriter.WriteString("" + s[w]);
                                                    desc_s[w] = reader[1].ToString();
                                                    titulo_s[w] = reader[2].ToString();
                                                    //myXmlTextWriter.WriteElementString("Descripcion", null, "" + desc_s[w]);
                                                    //myXmlTextWriter.WriteElementString("Titulo", null, "" + titulo_s[w]); 
                                                    w++;
                                                myXmlTextWriter.WriteEndElement();
                                            }                                      
                                    } 
                                myXmlTextWriter.WriteEndElement();
                            myXmlTextWriter.WriteEndElement();
                            } 
                        myXmlTextWriter.WriteEndElement();
                    }
                myXmlTextWriter.Flush();
                myXmlTextWriter.Close();
            }
            finally
            {
                conn.Close();
            }    
        }

        private void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int u = 0;
            string[] acts = new string[procesos];
            
            myGrid.Children.RemoveRange(9, myGrid.Children.Count);
            proc = comboBox1.SelectedIndex;
            p = comboBox1.SelectedValue.ToString();
            label2.Visibility = Visibility.Hidden;
            button3.Visibility = Visibility.Visible;
            label4.Content = ("PROCESO: " + (proc + 1));
            conn.Open();

            SqlCeCommand cmd3 = conn.CreateCommand();
            cmd3.CommandText = "SELECT actividad FROM esta_formado_por WHERE nombre='" + p + "'";
            reader = cmd3.ExecuteReader();
            cmd3.ExecuteNonQuery();         

            while (reader.Read())
            {
                acts[u] = reader[0].ToString();
                u++;
            }
            conn.Close();

            xDoc.Load("C:/Documents and Settings/LeticiaOsacar/Escritorio/ejemplos_c#/menu1/menu1/xml2.xml");
            //Realizar accion de leer el xml
            leerDatosGenerales(xDoc, p, out rectangulos, out duras, out deses, out titus, out aes);
            //Dibujar actividades
            dibujar_act(out act, rectangulos, duras);
          
        }

        public void recoger_coordenadas(out decimal cX, out decimal cY)
        {
            Point coordenada = Mouse.GetPosition(myGrid);
            string coordX = coordenada.X.ToString();
            string coordY = coordenada.Y.ToString();

            cX = decimal.Parse(coordX);
            cY = decimal.Parse(coordY);
        }

        public void indicar_tarea(decimal cX, decimal cY, out int tar)
        {
            if ((((cX >= 270) && (cX <= 416)) && (cY >= 55)) && (cY <= 202))
            {
                tarea = 0;
            }
            else if ((((cX >= 420) && (cX <= 566)) && (cY >= 55)) && (cY <= 202))
            {
                tarea = 1;
            }
            else if ((((cX >= 570) && (cX <= 716)) && (cY >= 55)) && (cY <= 202))
            {
                tarea = 2;
            }
            else if ((((cX >= 720) && (cX <= 950)) && (cY >= 50)) && (cY <= 202))
            {
                tarea = 3;
            }
            
            tar = tarea;
        }

        private string leerDatosGenerales(XmlDocument xml1, string p, out int recs, out string[] duras, out string[] deses, out string[] titus, out string[] aes)
        {
            string idProc = null;

            XmlNodeList listaProcesos = xDoc.SelectNodes("Procesos/Proceso");
            XmlNode unProceso;

            string[] actis = null;
            string[] dur_act = null;
            string[] desc_act = null;
            string[] titu_act = null;

            for (int h = 0; h < listaProcesos.Count; h++)
            {                
                //Obtenemos cada proceso.
                unProceso = listaProcesos.Item(h);
                //Seleccionamos el id del proceso.               
                idProc = (unProceso.SelectSingleNode("Id_proceso").InnerText);

                //Comprobamos que el id de empleado sea el mismo que el número introducido por el usuario.
                if (p == idProc)
                {
                    //Obtenemos la lista de telefonos.

                    XmlNodeList actividades = unProceso.SelectNodes("Actividad");
                    recs = actividades.Count;

                    actis = new string[recs];
                    dur_act = new string[recs];
                    desc_act = new string[recs];
                    titu_act = new string[recs];

                    for (int f = 0; f < actividades.Count; f++)
                    {
                        actis[f] = (string)(actividades[f].SelectSingleNode("Id_act").InnerText);
                        dur_act[f] = (string)(actividades[f].SelectSingleNode("Duracion").InnerText);
                        desc_act[f] = (string)(actividades[f].SelectSingleNode("Descripcion").InnerText);
                        titu_act[f] = (string)(actividades[f].SelectSingleNode("Titulo").InnerText);
                    }
                }   
            }

            duras = dur_act;
            deses = desc_act;
            titus = titu_act;
            recs = rectangulos;
            aes = actis;

            return "";
        }

        public void dibujar_act(out int act, int rectangulos, string[] dur_act)
        {
            act = rectangulos;
            int actual = 975;
            int grid_actual = 787;

            //Quiero aumentar el tamaño del aventana en funcion de las actividades que tenga
            //En los ejemplos no me dibuja todo porq los arrays estan con menos valores de lectura...
            if (act >= 4)
            {
                int poner = act - 4 + 1;
                
                Ventana_cargar.Width = actual;
                Ventana_cargar.Width = actual + (150 * poner);
                myGrid.Width = grid_actual + (160 * poner);
            }
            else if (act < 4) 
            {
                myGrid.Width = grid_actual;
                Ventana_cargar.Width = actual;
            }

            label3.Visibility = Visibility.Visible;
            OuterGlowBitmapEffect outer = new OuterGlowBitmapEffect();
            OuterGlowBitmapEffect outer2 = new OuterGlowBitmapEffect();

            int x = -100;
            int y = 50;
            int z = 0;
            int k = 0;

            //Matriz de controles
            rec = new Rectangle[1, act];
            int j;

            for (j = 0; j < act; j++)
            {
                rec[0, j] = new Rectangle();
                rec[0, j].Height = 45;
                rec[0, j].Width = 45;
                rec[0, j].Fill = System.Windows.Media.Brushes.LightBlue;
                rec[0, j].Margin = new Thickness(x, y, z, k);

                x += 300;
                y += 0;
                z += 0;
                k += 0;

                int dur = Int32.Parse(dur_act[j]);

                if (dur < 40)
                {
                    outer.GlowColor = Colors.Red;
                    outer.GlowSize = 15;
                    rec[0, j].BitmapEffect = outer;
                }
                else
                {
                    outer2.GlowColor = Colors.Green;
                    outer2.GlowSize = 15;
                    rec[0, j].BitmapEffect = outer2;
                }

                //Quitar el efecto glow
                //rec[i, j].BitmapEffect = null;

                //Aplicamos el estilo estilo_tarea a las tareas
                rec[0, j].Style = (Style)this.Resources["Estilo_tarea"];
                myGrid.Children.Add(rec[0, j]);
            }
        }   

        private void myGrid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            label1.Content = "";           
            recoger_coordenadas(out cX, out cY);
            indicar_tarea(cX, cY, out tarea);
            limpiar_grid1(i);
            label5.Visibility = Visibility.Visible;

            if (tarea >= 0)
            {                
                contar_sub(out subs, tarea, duras, deses, titus, aes);
                dibujar_sub(subs, tarea, out rec_sub, out rec_ant, out v, out i);    
            }
            tarea = -1;
        }

        private void myGrid_MouseLeave(object sender, MouseEventArgs e)
        {
            label1.Content = "";
            limpiar_grid1(i);
            recoger_coordenadas(out cX, out cY);
            indicar_tarea(cX, cY, out tarea);

            if (tarea >= 0)
            {
                for (int x = 0; x < act; x++)
                {
                    if (tarea != x)
                    {
                        rec[0, x].Visibility = Visibility.Visible;
                    }
                }
            }
            tarea = -1;
        }

        private void myGrid_MouseEnter(object sender, MouseEventArgs e)
        {
            label1.Content = "";
            recoger_coordenadas(out cX, out cY);
            indicar_tarea(cX, cY, out tarea);

            if (tarea >= 0)
            {
                for (int x = 0; x < act; x++)
                {
                    if (tarea != x)
                    {
                        rec[0, x].Visibility = Visibility.Hidden;
                    }
                }
            }
            tarea = -1;
        }
   
        public void contar_sub(out int subs, int tarea, string[] dur_act, string[] desc_act, string[] titu_act, string[] actis)
        {
            string ac = null;
            string[] nom_sub = new string[3];
            
            if (tarea == 0) 
            {
                ac = "act_1";
            }
            else if (tarea == 1) 
            {
                ac = "act_2";
            }
            else if (tarea == 2) 
            {
                ac = "act_3";
            }
            else if (tarea == 3) 
            {
                ac = "act_4";
            }

            XmlNode unProceso;
            string idProc = null;
            int s = 0;
            string k = null;
            XmlNodeList listaProcesos = xDoc.SelectNodes("Procesos/Proceso/Actividad");           

            for (int h = 0; h < listaProcesos.Count; h++)
            {
                unProceso = listaProcesos.Item(h);
                XmlNodeList subactividades = unProceso.SelectNodes("Subactividades/Subactividad");
                
                idProc = (unProceso.SelectSingleNode("Id_act").InnerText);

                //Comprobamos que el id de empleado sea el mismo que el número introducido por el usuario.
                if (ac == idProc)
                {                 
                    s = subactividades.Count;

                    for (int f = 0; f < subactividades.Count; f++)
                    {
                        nom_sub[f] = (string)(subactividades[f].InnerText);
                    }
                }
            }

            k = actis[tarea];
            label1.Content = ("INFORMACIÓN DE LA ACTIVIDAD \nActividad: "
                                     + (tarea + 1) + "\nNombre: "+ k +"\nDuracion: " + dur_act[tarea] + "\nDescripcion: "+ desc_act[tarea]+
                                     "\nTitulo: "+ titu_act[tarea]+" \n\nSubactividades: \n\t" + nom_sub[0] + "\n\t" + nom_sub[1] + "\n\t" + nom_sub[2]);
            subs = s;
        }

        public void dibujar_sub(int subs, int tarea, out Rectangle[,] rec_sub, out Rectangle[,] rec_ant , out int v, out int i)
        {
            int x = -100;
            int y = 0;
            int z = 0;
            int k = 0;
            int s;
            v = 0;       
            s = subs;
            rec_sub = new Rectangle[s, s];
            label5.Visibility = Visibility.Visible;

            for (i = 0; i < s; i++)
            {
                rec_sub[v, i] = new Rectangle();
                rec_sub[v, i].Height = 50;
                rec_sub[v, i].Width = 50;
                rec_sub[v, i].Fill = System.Windows.Media.Brushes.Black;
                rec_sub[v, i].Margin = new Thickness(x, y, z, k);

                x += +200;
                y += 0;
                z += 0;
                k += 0;

                //Aplicamos el estilo estilo_subtarea a las subtareas que creemos
                rec_sub[v, i].Style = (Style)(this.Resources["Estilo_subtarea"]);
                grid1.Children.Add(rec_sub[v, i]); 
            } 
            rec_ant = rec_sub;
        }

        public void limpiar_grid1(int i) 
        {
            if (grid1.Children.Count > 0)
            {
                for (int c = 0; c <= i; c++)
                {
                    grid1.Children.RemoveRange(1, c);
                }
            }
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            Cargar cargar = new Cargar();
            cargar.Show();
            this.Close();
        }      
    }  
}

